//+---------------------------------------------------------------------------+ 
//|                                                        .mq4 |
//+---------------------------------------------------------------------------+
//----
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Lime

//---- input parameters 
extern double       w1=0.1;
extern double       w2=0.1;

//---- buffers 
double ExtMapBuffer[];

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init()
  {
   SetIndexBuffer(0, ExtMapBuffer);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);

   int N=(10/w1);
   SetIndexDrawBegin(0,N);
   Print("N=",N);

   IndicatorShortName(" ()");
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit()
  { 
   return(0);
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   int i,j;
   double sum=0;
   if (Bars<1./w1) return(0);
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for (i = limit;i>=0;i--){
      if (ExtMapBuffer[i]==0) { ExtMapBuffer[i]=Close[i]; continue;}
      double tmp=w2*(MathPow(Close[i]-Close[i+1],2)-1.0);
      ExtMapBuffer[i]=w1*(Close[i]-ExtMapBuffer[i+1])+ExtMapBuffer[i+1]+ExtMapBuffer[i+1]*tmp/(1+tmp);
   }
   return(0);
  }
//+------------------------------------------------------------------+ 